package external

import (
	"encoding/json"
	"fmt"
	"github.com/gin-gonic/gin"
	"io/ioutil"
	"net/http"
	"strings"
)

type OpportunityAPI struct {
	Address string
}

func (api OpportunityAPI) GetOpportunityEndpoint(ctx *gin.Context) (endpoint string) {
	split := strings.Split(ctx.Request.RequestURI, "/")
	endpoint = strings.Join(split[2:], "/")
	return
}

func (api OpportunityAPI) SendRequest(ctx *gin.Context, endpoint string, method string) (res *http.Response, err error) {
	client := &http.Client{}
	req, err := http.NewRequest(method, fmt.Sprintf("http://%s/%s",api.Address,endpoint), ctx.Request.Body)
	if err == nil {
		for k, v := range ctx.Request.Header {
			req.Header.Set(k, v[0])
		}
		res, err = client.Do(req)
	}
	return
}

func (api OpportunityAPI) SetResponse(ctx *gin.Context, res *http.Response, err error) {
	if err == nil {
		var payloadMap map[string]interface{}
		payloadBytes, err := ioutil.ReadAll(res.Body)
		if err == nil {
			err := json.Unmarshal(payloadBytes, &payloadMap)
			if err == nil {
				ctx.JSON(res.StatusCode, payloadMap)
				return
			} else {
				ctx.JSON(http.StatusInternalServerError, gin.H{"error" : error.Error(err)})
			}
		} else {
			ctx.JSON(http.StatusInternalServerError, gin.H{"error" : error.Error(err)})
		}
	} else {
		ctx.JSON(http.StatusInternalServerError, gin.H{"error" : error.Error(err)})
	}
}

