package infrastructure

import (
	"go.mongodb.org/mongo-driver/bson/primitive"
	"institutionMS/layers/entity"
)

// DocumentDatabase is a database abstraction at infrastructure layer
type DocumentDatabase interface {
	Connect()
	Collection(database string, collection string)
	Create(institution entity.Institution) (id string, err error)
	Read(email string) (institution *entity.Institution, err error)
	Update(objId primitive.ObjectID, institution *entity.Institution) (updated *entity.Institution, err error)
	Delete(objId primitive.ObjectID) (deleted *entity.Institution, err error)
	Disconnect()
}
