package repository

import (
	"go.mongodb.org/mongo-driver/bson/primitive"
	"institutionMS/layers/entity"
)

// Repository is a repository abstraction at repository layer
type Repository interface {
	Create(institution entity.Institution) (id string, err error)
	Read(email string) (institution *entity.Institution, err error)
	Update(objId primitive.ObjectID, institution *entity.Institution) (updated *entity.Institution, err error)
	Delete(id primitive.ObjectID) (deleted *entity.Institution, err error)
}
