package service

import (
	"github.com/gin-gonic/gin"
	"institutionMS/external"
	"net/http"
)

type OpportunityService struct {
	Api external.OpportunityAPI
}

func (service OpportunityService) Create(ctx *gin.Context) {
	endpoint := service.Api.GetOpportunityEndpoint(ctx)
	res, err := service.Api.SendRequest(ctx, endpoint, http.MethodPost)
	service.Api.SetResponse(ctx, res, err)
}

func (service OpportunityService) Read(ctx *gin.Context) {
	endpoint := service.Api.GetOpportunityEndpoint(ctx)
	res, err := service.Api.SendRequest(ctx, endpoint, http.MethodGet)
	service.Api.SetResponse(ctx, res, err)
}

func (service OpportunityService) Update(ctx *gin.Context) {
	endpoint := service.Api.GetOpportunityEndpoint(ctx)
	res, err := service.Api.SendRequest(ctx, endpoint, http.MethodPut)
	service.Api.SetResponse(ctx, res, err)
}

func (service OpportunityService) Delete(ctx *gin.Context) {
	endpoint := service.Api.GetOpportunityEndpoint(ctx)
	res, err := service.Api.SendRequest(ctx, endpoint, http.MethodDelete)
	service.Api.SetResponse(ctx, res, err)
}