package service

import (
	"github.com/gin-gonic/gin"
	"log"
	"net/http"
	"os"
	"strconv"
)

// CheckAuthorized is a util function that checks if request is authorized
func CheckAuthorized(ctx *gin.Context) bool {
	noAuth := os.Getenv("NO_AUTH")
	b, err := strconv.ParseBool(noAuth)
	if err != nil {
		log.Fatal(err)
	}
	authorized := ctx.GetBool("authorized")
	if !authorized && !b {
		ctx.JSON(http.StatusUnauthorized, gin.H{"error": "Invalid token"})
		return false
	}
	return true
}
